/**
    @author songlinju
    @mail songlinju@maxthon.net
 */




;(function (window, document) {

    if (window.MXSearchTextInPage) return;

    var body = document.body, 
        getStyle = window.getComputedStyle, 

        styleNode = document.createElement("style"), 
        nodeClass = '__MaxthonSearchNode__', 
        currentNodeClass = '__MaxthonSearchCurrentNode__', 

        keyword = '', 
        keywordLength = 0, 
        currentIndex = 0, 
        nodes = [], 
        parents = [];

    // 创建节点样式表
    styleNode.setAttribute("type", "text/css");
    styleNode.appendChild(document.createTextNode('.' + nodeClass + '{ color: black !important; background: #ffff00 !important; display: inline !important; margin: 0 !important; padding: 0 !important; border: 0 !important; position: static !important; float: none !important; font: inherit !important; } ' + 
                                                  '.' + currentNodeClass + '{ background-color:#ff9632 !important; }'));


    // 查找文本节点内符合条件的元素
    function getSearchNode(element) {
        var value, idx, node, text, n = 0, tag = true;

        while (true) {
            value = element.nodeValue;
            idx = value.toLowerCase().indexOf(keyword);

            if (idx < 0) break;

            node = document.createElement("maxthon");
            node.setAttribute('class', nodeClass);
            node.appendChild(document.createTextNode(value.substr(idx, keywordLength)));
            text = document.createTextNode(value.substr(idx + keywordLength));
            element.deleteData(idx, value.length - idx);
            element.parentNode.insertBefore(text, element.nextSibling);
            element.parentNode.insertBefore(node, element.nextSibling);
            element = text;

            // 因为节点是倒序查找，所以要通过该方法保证查找结果的正确顺序
            nodes.splice(n++, 0, node);

            // 同一个父节点只被添加一次，防止大文本节点多次normalize，严重影响效率
            if (tag) {
                tag = false;
                parents.push(node.parentNode);
            }
        }
    }

    // 对所有节点排查，text节点交给 getSearchNode处理
    function searchValue(element) {
        if (!element) return;
        var style, elementName;

        if (element.nodeType == 3) {
            getSearchNode(element);
        } else if (element.nodeType == 1 

            && (elementName = element.nodeName)
            && elementName != 'SCRIPT' 
            && elementName != 'SELECT' 
            && elementName != 'IFRAME' 
            && elementName != 'STYLE' 

            && (style = getStyle(element))
            && style.display != 'none' 
            && style.opacity != 0 
            && style.visibility != 'hidden') {

            // 必须倒序，因为 getSearchNode 方法会创建新的节点，正序就会重复查询
            for (var i = element.childNodes.length - 1; i >= 0; i--) {
                searchValue(element.childNodes[i]);
            }
        }
    }

    // 清理搜索标签残留
    function clearSearch() {

        nodes.forEach(function (element) {
            element.parentNode.insertBefore(element.removeChild(element.firstChild), element);
            element.parentNode.removeChild(element);
        });

        parents.forEach(function(element) {
            element.normalize();
        });
    }

    // 设置当前节点样式并显示在窗口可见区域
    function setCurrentNode() {
        if (!nodes[currentIndex]) return;
        nodes[currentIndex].classList.add(currentNodeClass);
        nodes[currentIndex].scrollIntoViewIfNeeded();
    }

    // 查找
    function MXSearchTextInPage(value) {

        clearSearch();
        !body.contains(styleNode) && body.appendChild(styleNode);

        nodes = [];
        parents = [];
        currentIndex = 0;

        keyword = value.trim().toLowerCase();
        keywordLength = keyword.length;
        keyword !== '' && searchValue(body);
        setCurrentNode();

        return nodes.length;
    }

    // 结束搜索
    function MXSearchTextInPageDone() {
        clearSearch();
        body.contains(styleNode) && body.removeChild(styleNode);
        nodes = [];
        parents = [];
    }

    // next == true 下一个；next == false 上一个
    function MXSelectNextSearchedTextInPage(next) {
        var length = nodes.length;

        if (!length) {
            return 0;
        }

        nodes[currentIndex].classList.remove(currentNodeClass);
        if (!!next) {
            if (currentIndex >= length - 1) {
                currentIndex = 0;
            } else {
                currentIndex++;
            }
        } else {
            if (currentIndex <= 0) {
                currentIndex = length - 1;
            } else {
                currentIndex--;
            }
        }
        setCurrentNode();

        return currentIndex + 1;
    }


    window.MXSearchTextInPage = MXSearchTextInPage;
    window.MXSearchTextInPageDone = MXSearchTextInPageDone;
    window.MXSelectNextSearchedTextInPage = MXSelectNextSearchedTextInPage;

})(window, document);



